/*
This is a small example how to use chm library. Written by Mikhail Kostousov <mikhail.kostousov@gmail.com>
*/


#ifdef QTOPIA
#include <qtopia/qpeapplication.h>
#else
#include <qapplication.h>
#endif

#include <qregexp.h>
#include <sys/stat.h>

#include "chmfile.h"

int main(int argv,char **argc)
{	
	QString chmFileName;
	QString dir="./";
	int i=0;
	while(i<argv)
	{
		if ((QString(argc[i])=="-f")&& i+1 < argv)
		{
			chmFileName=argc[++i];
		}else if ((QString(argc[i])=="-d")&& i+1 < argv)
		{
			dir=argc[++i];
		}else if (QString(argc[i])=="-h")
		{
		    printf("usage:\n %s -f <filename> [-d direcotoryName]\n",argc[0]);
		    return 0;
		}
		i++;

	}

	ChmDirectoryMap chmDirectoryMap;
	QByteArray byteArray;
	Chm chm;
	chm.read(chmFileName,chmDirectoryMap,byteArray);	//open and decompress chm file
	char *buf=byteArray.data();				//get byte buf

	for (ChmDirectoryMap::Iterator it=chmDirectoryMap.begin();it!=chmDirectoryMap.end();it++)	//Follow entry by entry whole book
	{

		QString fileName=it.key();
		if ((!fileName.contains(QRegExp("/(#|\\$)")))&& (fileName.contains(QRegExp("^/"))))	//if entry is a regular file or directory
		{
			QString dirName;
			if (fileName.contains(QRegExp("^/[^/]+/")))					//if entry is a directory
			{
				int dirIndex=1;
				int i=dirIndex;
				while (i>0)								//we create recursive directories
				{
					dirIndex=i;
					i=fileName.find("/",dirIndex+1);
					mkdir(fileName.mid(1,dirIndex-1).latin1(),0777);		//it's not so good, we need to check is the directory 
													//exists or not

				}
			}
			if (fileName.contains(QRegExp("[^/]$")))					//if entry is a file
			{       
				printf("%s\n",fileName.latin1());
				FILE *f=fopen(fileName.right(fileName.length()-1).latin1(),"wb");	//we create file
				fwrite(buf+it.data().offset,1,it.data().length,f);			//put data from buffer
				fclose(f);								
			}
		}
	}
	return 0;	

}
